ELRepo Bugtracker

Viewing Issue Simple Details Jump to Notes ] View Advanced ] Issue History ] Print ]
ID Category Severity Reproducibility Date Submitted Last Update
0000189 [channel: elrepo/el6] kmod-atl1e crash sometimes 2011-10-10 17:12 2012-04-19 18:01
Reporter rkl View Status public  
Assigned To pperry
Priority normal Resolution not fixable  
Status resolved  
Summary 0000189: kmod-atl1e driver crashes during sustained heavy network traffic
Description I'm using kmod-atl1e-1.0.1.14-1.el6.elrepo.x86_64 with the latest 64-bit CentOS 6 kernel (2.6.32-131.12.1.el6.x86_64) on a Dell Zino HD with an Atheros AR8151 gigabit ethernet adapter. It's attached to a 100Mbit/sec switch that appears to have auto-neg'ed correctly according to ethtool.

At times of sustained heavy network traffic (usually via large multiple file copies across the network_using NFS, rsync or sftp, the network connection locks solid after anything between 2 and 20 minutes. As a side point, forcing autoneg off via ethool (e.g. "ethtool -s eth0 speed 100 duplex full autoneg off") also locks up the network connection in an identical manner (the lights go off completely on the network socket).
Additional Information I was trying to find the original source for this package and the URL that everyone quotes ( http://partner.atheros.com/Drivers.aspx [^] ) is badly broken with a Bad Request error :-( I ended up finding it on a filesharing site of all places! Unpacking that source reveals that there are various options to change size of buffers etc. for the driver - I'm wondering if it's simply running out of transmit/receive buffers and crashing out at high traffic levels? Maybe the driver needs a rebuild with higher default buffer values (I'm just grabbing at straws here)?
Tags No tags attached.
Attached Files

- Relationships
related to 0000243resolvedrg compat-wireless can now be build against el6 kernels -- why not do it? :) 

-  Notes
(0001129)
pperry (administrator)
2011-10-13 11:07

Hmm, it would appear that Atheros has been purchased by Qualcomm, and we can't seem to find the driver sources on the new site, making it somewhat hard to continue to update these drivers.

If anyone can find a link to the sources, it would be useful.

WRT the driver version in question - obviously we have the source available as part our our SRPM so a rebuild with different parameters is possible although ideally I'd prefer to see such issues fixed upstream (with Qualcomm now).
(0001196)
rkl (reporter)
2011-11-07 10:33

A little bit of detective work turned up the fact it looks like the atl1e driver is to be abandoned by Qualcomm Atheros and a new driver, "alx", is in development to replace it:

http://comments.gmane.org/gmane.linux.network/200232 [^]

Unfortunately from the above URL, the engineer put on the case to do it seems somewhat inexperienced with kernel network driver development if the initial conversation is to be believed :-(

It does look like a patch for alx has turned up though:

http://comments.gmane.org/gmane.linux.kernel/1205207 [^]

At what it will be "backportable" to CentOS 6's 2.6.32 kernel is anyone's guess - let's hope nothing post-2.6.32 is used by the new alx driver...
(0001750)
rkl (reporter)
2012-03-02 08:39

The alx driver has been released here:

http://www.linuxfoundation.org/collaborate/workgroups/networking/alx [^]

I have downloaded the compat-wireless package that they link and it works fine in my setup:

http://www.orbit-lab.org/kernel/compat-wireless/2012/02/compat-wireless-2012-02-28-p.tar.bz2 [^]

Can I therefore suggest that you look at providing kmod-alx as RPMs on ELRepo? The alx driver is intended to completely replace the old atl1e driver.
(0001752)
burakkucat (administrator)
2012-03-02 12:07

Re. note 1750. Thank you for the update.

I have just one query. You mention a "compat-wireless" package and then later suggest that it be used to replace the atl1e driver. The atl1e kmod package that we currently provide is for wired, not wireless, connections.

Please clarify the situation.
(0001753)
rkl (reporter)
2012-03-02 15:43

The alx driver has been added to the compat-wireless package, which did indeed confuse me initially because the name almost suggests that the package just contains wireless drivers for old devices! This isn't true, however, because if you download the compat-wireless package, it actually contains wireless, wired and even Bluetooth drivers in it.

If you run "scripts/driver-select" with no parameters from inside the unpacked compat-wireless package, you get a full list of all the drivers included:

Usage: scripts/driver-select [ <driver-name> | <driver-group-name> | restore ]
Supported 802.11 drivers:
    ath5k
    ath9k
    ath9k_htc
    carl9170
    ath6kl
    b43
    zd1211rw
    rt2x00
    wl1251
    wl12xx
    brcmsmac
    brcmfmac

Supported Ethernet drivers:
    atl1
    atl2
    atl1e
    atl1c
    alx

Supported group drivers:
    atheros < ath5k ath9k carl9170 zd1211rw ath6kl >
    ath < ath5k ath9k carl9170 ath6kl >
    brcm80211 < brcmsmac brcmfmac >
    intel < iwlwifi, iwlegacy >
    rtl818x < rtl8180 rtl8187 >
    rtlwifi < rtl8192ce >
    ti < wl1251 wl12xx (SPI and SDIO)>

Supported group drivers: Bluetooth & Ethernet:
    atlxx < atl1 atl2 atl1e alx>
    bt < Linux bluetooth drivers >
Restoring compat-wireless:
    restore: you can use this option to restore compat-wireless to the original state

So the build sequence I used was:

bzcat compat-wireless-2012-02-28-p.tar.bz2 | tar xvf -
cd compat-wireless-2012-02-28-p
scripts/driver-select alx
make
make install

It should be noted that alx has a dependency on the compat module that's also installed via "make install". I tracked down what actually gets run and installed - here's what happens:

 Command: version="`uname -r`"
 Installed: /lib/modules/$version/updates/compat/compat.ko
 Installed: /lib/modules/$version/updates/compat/compat_firmware_class.ko
 Installed: /lib/modules/$version/updates/drivers/net/ethernet/atheros/alx/alx.ko
 Installed: /lib/udev/compat_firmware.sh
 Installed: /lib/udev/rules.d/50-compat_firmware.rules
 Command: cd /lib/modules/$version/build
 Command: /sbin/depmod -ae -F System.map $version
 Command: /sbin/depmod -a

It should be noted that there are various scripts also installed into /usr/sbin, but you don't really need them at all. I'm not sure about the two udev files installed (are they used?), but I've included them to be safe.
(0001754)
burakkucat (administrator)
2012-03-02 15:56

Thank you for clarifying the issue and thus erasing my confusion.

That package looks very interesting. I have added it to the bottom of my ToDo list and I will try to get the alx package built as soon as possible.
(0001821)
pperry (administrator)
2012-03-10 12:38

There is an active RFE for compat-wireless here:

http://elrepo.org/bugs/view.php?id=243 [^]

However, I'm not sure if the alx driver is included in that 3.3-rc1 tarball. The list of drivers in the latest package is:

$ find . -name *.ko
./net/mac80211/mac80211.ko
./compat/compat.ko
./drivers/ssb/ssb.ko
./drivers/net/usb/usbnet.ko
./drivers/net/usb/rndis_host.ko
./drivers/net/usb/cdc_ether.ko
./drivers/net/ethernet/broadcom/b44.ko
./drivers/net/ethernet/atheros/atl1c/atl1c.ko
./drivers/net/ethernet/atheros/atl1e/atl1e.ko
./drivers/net/ethernet/atheros/atlx/atl1.ko
./drivers/net/ethernet/atheros/atlx/atl2.ko
./drivers/net/wireless/p54/p54usb.ko
./drivers/net/wireless/p54/p54common.ko
./drivers/net/wireless/p54/p54pci.ko
./drivers/net/wireless/mac80211_hwsim.ko
./drivers/net/wireless/rndis_wlan.ko
./drivers/net/wireless/wl12xx/wl12xx.ko
./drivers/net/wireless/b43legacy/b43legacy.ko
./drivers/net/wireless/iwlwifi/iwlwifi.ko
./drivers/net/wireless/mwl8k.ko
./drivers/net/wireless/mwifiex/mwifiex_sdio.ko
./drivers/net/wireless/mwifiex/mwifiex.ko
./drivers/net/wireless/mwifiex/mwifiex_pcie.ko
./drivers/net/wireless/b43/b43.ko
./drivers/net/wireless/rtl818x/rtl8180/rtl8180.ko
./drivers/net/wireless/rtl818x/rtl8187/rtl8187.ko
./drivers/net/wireless/wl1251/wl1251.ko
./drivers/net/wireless/zd1211rw/zd1211rw.ko
./drivers/net/wireless/rt2x00/rt2400pci.ko
./drivers/net/wireless/rt2x00/rt73usb.ko
./drivers/net/wireless/rt2x00/rt2800usb.ko
./drivers/net/wireless/rt2x00/rt2500pci.ko
./drivers/net/wireless/rt2x00/rt2x00pci.ko
./drivers/net/wireless/rt2x00/rt2x00usb.ko
./drivers/net/wireless/rt2x00/rt2800lib.ko
./drivers/net/wireless/rt2x00/rt2800pci.ko
./drivers/net/wireless/rt2x00/rt2x00lib.ko
./drivers/net/wireless/rt2x00/rt61pci.ko
./drivers/net/wireless/rt2x00/rt2500usb.ko
./drivers/net/wireless/at76c50x-usb.ko
./drivers/net/wireless/adm8211.ko
./drivers/net/wireless/iwlegacy/iwlegacy.ko
./drivers/net/wireless/iwlegacy/iwl3945.ko
./drivers/net/wireless/iwlegacy/iwl4965.ko
./drivers/net/wireless/libertas_tf/libertas_tf.ko
./drivers/net/wireless/libertas_tf/libertas_tf_usb.ko
./drivers/net/wireless/orinoco/orinoco.ko
./drivers/net/wireless/orinoco/orinoco_tmd.ko
./drivers/net/wireless/orinoco/orinoco_nortel.ko
./drivers/net/wireless/orinoco/orinoco_pci.ko
./drivers/net/wireless/orinoco/orinoco_cs.ko
./drivers/net/wireless/orinoco/spectrum_cs.ko
./drivers/net/wireless/orinoco/orinoco_usb.ko
./drivers/net/wireless/orinoco/orinoco_plx.ko
./drivers/net/wireless/iwmc3200wifi/iwmc3200wifi.ko
./drivers/net/wireless/ipw2x00/libipw.ko
./drivers/net/wireless/ipw2x00/ipw2200.ko
./drivers/net/wireless/ipw2x00/ipw2100.ko
./drivers/net/wireless/rtlwifi/rtl8192c/rtl8192c-common.ko
./drivers/net/wireless/rtlwifi/rtl8192ce/rtl8192ce.ko
./drivers/net/wireless/rtlwifi/rtl8192cu/rtl8192cu.ko
./drivers/net/wireless/rtlwifi/rtl8192de/rtl8192de.ko
./drivers/net/wireless/rtlwifi/rtl8192se/rtl8192se.ko
./drivers/net/wireless/rtlwifi/rtlwifi.ko
./drivers/net/wireless/libertas/libertas_cs.ko
./drivers/net/wireless/libertas/libertas_sdio.ko
./drivers/net/wireless/libertas/libertas.ko
./drivers/net/wireless/libertas/usb8xxx.ko
./drivers/net/wireless/ath/ath.ko
./drivers/net/wireless/ath/carl9170/carl9170.ko
./drivers/net/wireless/ath/ath5k/ath5k.ko
./drivers/net/wireless/ath/ath6kl/ath6kl.ko
./drivers/net/wireless/ath/ath9k/ath9k_htc.ko
./drivers/net/wireless/ath/ath9k/ath9k.ko
./drivers/net/wireless/ath/ath9k/ath9k_hw.ko
./drivers/net/wireless/ath/ath9k/ath9k_common.ko
./drivers/net/wireless/brcm80211/brcmfmac/brcmfmac.ko
./drivers/net/wireless/brcm80211/brcmutil/brcmutil.ko
./drivers/net/wireless/brcm80211/brcmsmac/brcmsmac.ko
./drivers/bluetooth/ath3k.ko
./drivers/bluetooth/hci_uart.ko
./drivers/bluetooth/bt3c_cs.ko
./drivers/bluetooth/bpa10x.ko
./drivers/bluetooth/btsdio.ko
./drivers/bluetooth/dtl1_cs.ko
./drivers/bluetooth/bfusb.ko
./drivers/bluetooth/btmrvl.ko
./drivers/bluetooth/btusb.ko
./drivers/bluetooth/btmrvl_sdio.ko
./drivers/bluetooth/btuart_cs.ko
./drivers/bluetooth/bcm203x.ko
./drivers/bluetooth/bluecard_cs.ko
./drivers/bluetooth/hci_vhci.ko
./drivers/bcma/bcma.ko
./drivers/misc/eeprom/eeprom_93cx6.ko
(0001890)
pperry (administrator)
2012-03-20 07:23

For info,

A compat-wireless package is now available for those who would like to test.

The alx driver doesn't yet appeared to have made it into the stable branch but atl1e.ko is there so I don't know if that provides a better option than the kmod-atl1e driver? I'm assuming the alx driver will filter down to the stable branch in due course.

Please feel free to provide any feedback if you are able to test.

Thanks.
(0001912)
rkl (reporter)
2012-03-26 15:37

Unfortunately, the atl1e driver situation got so bad for us (a crash a day with the Zinos), that there would be mutiny at work if I tried that driver again. We've had zero problems with alx, so I'm sticking with that. If/when alx appears in compat-wireless officially, then we'd be willing to try whatever you package up.
(0001913)
pperry (administrator)
2012-03-26 22:02

OK, thanks for that.
(0002038)
pperry (administrator)
2012-04-19 17:59

I'm going to close this bug now. We can test the alx driver as and when it makes it into the compat-wireless package.

- Issue History
Date Modified Username Field Change
2011-10-10 17:12 rkl New Issue
2011-10-10 17:12 rkl Status new => assigned
2011-10-10 17:12 rkl Assigned To => burakkucat
2011-10-13 11:07 pperry Note Added: 0001129
2011-11-07 10:33 rkl Note Added: 0001196
2012-03-02 08:39 rkl Note Added: 0001750
2012-03-02 12:07 burakkucat Note Added: 0001752
2012-03-02 12:07 burakkucat Status assigned => feedback
2012-03-02 15:43 rkl Note Added: 0001753
2012-03-02 15:56 burakkucat Note Added: 0001754
2012-03-02 15:56 burakkucat Status feedback => assigned
2012-03-06 16:51 toracat Relationship added related to 0000243
2012-03-09 16:52 burakkucat Assigned To burakkucat => pperry
2012-03-10 12:38 pperry Note Added: 0001821
2012-03-20 07:23 pperry Note Added: 0001890
2012-03-26 15:37 rkl Note Added: 0001912
2012-03-26 22:02 pperry Note Added: 0001913
2012-04-19 17:59 pperry Note Added: 0002038
2012-04-19 18:01 pperry Status assigned => resolved
2012-04-19 18:01 pperry Resolution open => not fixable


Mantis 1.1.8[^]
Copyright © 2000 - 2009 Mantis Group
Powered by Mantis Bugtracker